#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * McSvcChannelDispatcherFuture:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _McSvcChannelDispatcherFuture McSvcChannelDispatcherFuture;

/**
 * McSvcChannelDispatcherFutureClass:
 *
 * The class of McSvcChannelDispatcherFuture.
 */
typedef struct _McSvcChannelDispatcherFutureClass McSvcChannelDispatcherFutureClass;

GType mc_svc_channel_dispatcher_future_get_type (void);
#define MC_TYPE_SVC_CHANNEL_DISPATCHER_FUTURE \
  (mc_svc_channel_dispatcher_future_get_type ())
#define MC_SVC_CHANNEL_DISPATCHER_FUTURE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), MC_TYPE_SVC_CHANNEL_DISPATCHER_FUTURE, McSvcChannelDispatcherFuture))
#define MC_IS_SVC_CHANNEL_DISPATCHER_FUTURE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), MC_TYPE_SVC_CHANNEL_DISPATCHER_FUTURE))
#define MC_SVC_CHANNEL_DISPATCHER_FUTURE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), MC_TYPE_SVC_CHANNEL_DISPATCHER_FUTURE, McSvcChannelDispatcherFutureClass))


typedef void (*mc_svc_channel_dispatcher_future_create_channel_with_hints_impl) (McSvcChannelDispatcherFuture *self,
    const gchar *in_Account,
    GHashTable *in_Requested_Properties,
    gint64 in_User_Action_Time,
    const gchar *in_Preferred_Handler,
    GHashTable *in_Hints,
    DBusGMethodInvocation *context);
void mc_svc_channel_dispatcher_future_implement_create_channel_with_hints (McSvcChannelDispatcherFutureClass *klass, mc_svc_channel_dispatcher_future_create_channel_with_hints_impl impl);
/**
 * mc_svc_channel_dispatcher_future_return_from_create_channel_with_hints:
 * @context: The D-Bus method invocation context
 * @out_Request: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void mc_svc_channel_dispatcher_future_return_from_create_channel_with_hints (DBusGMethodInvocation *context,
    const gchar *out_Request);
static inline void
mc_svc_channel_dispatcher_future_return_from_create_channel_with_hints (DBusGMethodInvocation *context,
    const gchar *out_Request)
{
  dbus_g_method_return (context,
      out_Request);
}

typedef void (*mc_svc_channel_dispatcher_future_ensure_channel_with_hints_impl) (McSvcChannelDispatcherFuture *self,
    const gchar *in_Account,
    GHashTable *in_Requested_Properties,
    gint64 in_User_Action_Time,
    const gchar *in_Preferred_Handler,
    GHashTable *in_Hints,
    DBusGMethodInvocation *context);
void mc_svc_channel_dispatcher_future_implement_ensure_channel_with_hints (McSvcChannelDispatcherFutureClass *klass, mc_svc_channel_dispatcher_future_ensure_channel_with_hints_impl impl);
/**
 * mc_svc_channel_dispatcher_future_return_from_ensure_channel_with_hints:
 * @context: The D-Bus method invocation context
 * @out_Request: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void mc_svc_channel_dispatcher_future_return_from_ensure_channel_with_hints (DBusGMethodInvocation *context,
    const gchar *out_Request);
static inline void
mc_svc_channel_dispatcher_future_return_from_ensure_channel_with_hints (DBusGMethodInvocation *context,
    const gchar *out_Request)
{
  dbus_g_method_return (context,
      out_Request);
}



G_END_DECLS
